-- name: [CS] Koopalings
-- description: Skinpack of the dreaded KOOPALINGS! \n\n\\#ff7777\\This Pack requires Character Select AND Coop Bowser Moveset Mod\nto use as a Library!

local E_MODEL_LARRY = smlua_model_util_get_id("larry_geo")
local E_MODEL_LEMMY = smlua_model_util_get_id("lemmy_geo")
local E_MODEL_WENDY = smlua_model_util_get_id("wendy_geo")
local E_MODEL_LUDWIG = smlua_model_util_get_id("ludwig_geo")
local E_MODEL_MORTON = smlua_model_util_get_id("morton_geo")
local E_MODEL_ROY = smlua_model_util_get_id("roy_geo")
local E_MODEL_IGGY = smlua_model_util_get_id("iggy_geo")


local TEX_LARRY = get_texture_info("larry_icon")
local TEX_LEMMY = get_texture_info("lemmy_icon")
local TEX_WENDY = get_texture_info("wendy_icon")
local TEX_LUDWIG = get_texture_info("ludwig_icon")
local TEX_MORTON = get_texture_info("morton_icon")
local TEX_ROY = get_texture_info("roy_icon")
local TEX_IGGY = get_texture_info("iggy_icon")

local VOICETABLE_LARRY = {
    [CHAR_SOUND_ATTACKED] = 'larry_hurt1.ogg',
    [CHAR_SOUND_COUGHING1] = 'larry_coughing1.ogg',
    [CHAR_SOUND_DOH] = 'larry_doh.ogg',
    [CHAR_SOUND_DROWNING] = 'larry_drowning.ogg',
    [CHAR_SOUND_DYING] = 'larry_dying.ogg',
    [CHAR_SOUND_EEUH] = 'larry_eeuh.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'larry_ground_pound_wah.ogg',
    [CHAR_SOUND_HAHA] = 'larry_haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'larry_haha.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'larry_here_we_go.ogg',
    [CHAR_SOUND_HOOHOO] = 'larry_hoohoo2.ogg',
    [CHAR_SOUND_HRMM] = 'larry_hrmm.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'larry_mamamia.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'larry_lets_a_go.ogg',
    [CHAR_SOUND_ON_FIRE] = 'larry_on_fire.ogg',
    [CHAR_SOUND_OOOF] = 'larry_ooof.ogg',
    [CHAR_SOUND_OOOF2] = 'larry_ooof.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'larry_punch_hoo.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'larry_punch_wah.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'larry_punch_yah.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'larry_larry.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'larry_yahoo2.ogg',
    [CHAR_SOUND_UH2] = 'larry_uh.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'larry_waaaooow.ogg',
    [CHAR_SOUND_WAH2] = 'larry_wah2.ogg',
    [CHAR_SOUND_WHOA] = 'larry_whoa2.ogg',
    [CHAR_SOUND_YAHOO] = 'larry_yahoo.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'larry_yahoo.ogg', 'larry_yipee.ogg', 'larry_waha.ogg' },
    [CHAR_SOUND_YAH_WAH_HOO] = { 'larry_yah.ogg', 'larry_wah2.ogg' },
}

local VOICETABLE_LEMMY = {
    [CHAR_SOUND_ATTACKED] = 'lemmy_hurt.ogg',
    [CHAR_SOUND_COUGHING1] = 'lemmy_coughing.ogg',
    [CHAR_SOUND_DOH] = 'lemmy_doh.ogg',
    [CHAR_SOUND_DROWNING] = 'lemmy_drowning.ogg',
    [CHAR_SOUND_DYING] = 'lemmy_dying.ogg',
    [CHAR_SOUND_EEUH] = 'lemmy_eeuh.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'lemmy_haha2.ogg',
    [CHAR_SOUND_HAHA] = 'lemmy_haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'lemmy_haha.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'lemmy_here_we_go.ogg',
    [CHAR_SOUND_HOOHOO] = 'lemmy_hoohoo.ogg',
    [CHAR_SOUND_HRMM] = 'lemmy_hrmm.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'lemmy_mamamia.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'lemmy_lets_a_go.ogg',
    [CHAR_SOUND_ON_FIRE] = 'lemmy_on_fire.ogg',
    [CHAR_SOUND_OOOF] = 'lemmy_ooof.ogg',
    [CHAR_SOUND_OOOF2] = 'lemmy_ooof.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'lemmy_punch_hoo.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'lemmy_punch_wah.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'lemmy_punch_yah.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'lemmy_so_longa_bowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'lemmy_twirl_bounce.ogg',
    [CHAR_SOUND_UH2] = 'lemmy_uh.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'lemmy_waaaooow.ogg',
    [CHAR_SOUND_WAH2] = 'lemmy_wah2.ogg',
    [CHAR_SOUND_WHOA] = 'lemmy_whoa.ogg',
    [CHAR_SOUND_YAHOO] = 'lemmy_yahoo.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'lemmy_yahoo.ogg', 'lemmy_yahoo2.ogg', 'lemmy_waha.ogg', 'lemmy_yahoo3.ogg', 'lemmy_yahoo5.ogg', 'lemmy_yahoo6.ogg', 'lemmy_yipee2.ogg', 'lemmy_yipee.ogg' },
    [CHAR_SOUND_YAH_WAH_HOO] = { 'lemmy_yah.ogg', 'lemmy_yah2.ogg', 'lemmy_yah3.ogg' },
}

local VOICETABLE_WENDY = {
    [CHAR_SOUND_ATTACKED] = 'Wendy_CHAR_SOUND_ATTACKED.ogg',
    [CHAR_SOUND_DOH] = 'Wendy_CHAR_SOUND_DOH.ogg',
    [CHAR_SOUND_DROWNING] = 'Wendy_CHAR_SOUND_DROWNING.ogg',
    [CHAR_SOUND_DYING] = 'Wendy_CHAR_SOUND_DYING.ogg',
    [CHAR_SOUND_EEUH] = 'Wendy_CHAR_SOUND_EEUH.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'Wendy_CHAR_SOUND_GROUND_POUND_WAH.ogg',
    [CHAR_SOUND_HAHA] = 'Wendy_CHAR_SOUND_HAHA.ogg',
    [CHAR_SOUND_HAHA_2] = 'Wendy_CHAR_SOUND_HAHA2.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'Wendy_CHAR_SOUND_HERE_WE_GO.ogg',
    [CHAR_SOUND_HOOHOO] = 'Wendy_CHAR_SOUND_HOOHOO.ogg',
    [CHAR_SOUND_HRMM] = 'Wendy_CHAR_SOUND_HRMM.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'Wendy_CHAR_SOUND_MAMA_MIA.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'Wendy_CHAR_SOUND_LETS_A_GO.ogg',
    [CHAR_SOUND_ON_FIRE] = 'Wendy_CHAR_SOUND_ON_FIRE.ogg',
    [CHAR_SOUND_OOOF] = 'Wendy_CHAR_SOUND_OOOF.ogg',
    [CHAR_SOUND_OOOF2] = 'Wendy_CHAR_SOUND_OOOF2.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'Wendy_CHAR_SOUND_PUNCH_HOO.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'Wendy_CHAR_SOUND_PUNCH_WAH.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'Wendy_CHAR_SOUND_PUNCH_YAH.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'Wendy_CHAR_SOUND_SO_LONGA_BOWSER.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'Wendy_CHAR_SOUND_TWIRL_BOUNCE.ogg',
    [CHAR_SOUND_UH] = 'Wendy_CHAR_SOUND_UH2_2.ogg',
    [CHAR_SOUND_UH2] = 'Wendy_CHAR_SOUND_UH2_2.ogg',
    [CHAR_SOUND_UH2_2] = 'Wendy_CHAR_SOUND_UH2_2.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'Wendy_CHAR_SOUND_WAAAOOOW.ogg',
    [CHAR_SOUND_WAH2] = 'Wendy_CHAR_SOUND_GROUND_POUND_WAH.ogg',
    [CHAR_SOUND_WHOA] = 'Wendy_CHAR_SOUND_WHOA.ogg',
    [CHAR_SOUND_YAHOO] = 'Wendy_CHAR_SOUND_YAHOO.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'Wendy_CHAR_SOUND_YAHOO.ogg', 'Wendy_CHAR_SOUND_YAHOO_WAHA_YIPPEE.ogg', 'Wendy_CHAR_SOUND_YAHOO_WAHA_YIPPEE2.ogg', 'Wendy_CHAR_SOUND_YAHOO_WAHA_YIPPEE3.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = { 'Wendy_CHAR_SOUND_YAH_WAH_HOO.ogg', 'Wendy_CHAR_SOUND_YAH_WAH_HOO2.ogg'},
}

local VOICETABLE_LUDWIG = {
    [CHAR_SOUND_ATTACKED] = 'Ludwig_CHAR_SOUND_ATTACKED.ogg',
    [CHAR_SOUND_COUGHING1] = 'Ludwig_CHAR_SOUND_COUGHING1.ogg',
    [CHAR_SOUND_COUGHING2] = 'Ludwig_CHAR_SOUND_COUGHING2.ogg',
    [CHAR_SOUND_DOH] = 'Ludwig_CHAR_SOUND_DOH.ogg',
    [CHAR_SOUND_DROWNING] = 'Ludwig_CHAR_SOUND_DROWNING.ogg',
    [CHAR_SOUND_DYING] = 'Ludwig_CHAR_SOUND_DYING.ogg',
    [CHAR_SOUND_EEUH] = 'Ludwig_CHAR_SOUND_EEUH.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'Ludwig_CHAR_SOUND_GROUND_POUND_WAH.ogg',
    [CHAR_SOUND_HAHA] = 'Ludwig_CHAR_SOUND_HAHA.ogg',
    [CHAR_SOUND_HAHA_2] = 'Ludwig_CHAR_SOUND_HAHA2.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'Ludwig_CHAR_SOUND_HERE_WE_GO.ogg',
    [CHAR_SOUND_HOOHOO] = 'Ludwig_CHAR_SOUND_HOOHOO.ogg',
    [CHAR_SOUND_HRMM] = 'Ludwig_CHAR_SOUND_HRMM.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'Ludwig_CHAR_SOUND_MAMA_MIA.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'Ludwig_CHAR_SOUND_LETS_A_GO.ogg',
    [CHAR_SOUND_ON_FIRE] = 'Ludwig_CHAR_SOUND_ON_FIRE.ogg',
    [CHAR_SOUND_OOOF] = 'Ludwig_CHAR_SOUND_OOOF.ogg',
    [CHAR_SOUND_OOOF2] = 'Ludwig_CHAR_SOUND_OOOF2.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'Ludwig_CHAR_SOUND_PUNCH_HOO.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'Ludwig_CHAR_SOUND_PUNCH_WAH.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'Ludwig_CHAR_SOUND_PUNCH_YAH.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'Ludwig_CHAR_SOUND_SO_LONGA_BOWSER.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'Ludwig_CHAR_SOUND_TWIRL_BOUNCE.ogg',
    [CHAR_SOUND_UH] = 'Ludwig_CHAR_SOUND_UH.ogg',
    [CHAR_SOUND_UH2] = 'Ludwig_CHAR_SOUND_UH2.ogg',
    [CHAR_SOUND_UH2_2] = 'Ludwig_CHAR_SOUND_UH2_2.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'Ludwig_CHAR_SOUND_WAAAOOOW.ogg',
    [CHAR_SOUND_WAH2] = 'Ludwig_CHAR_SOUND_GROUND_POUND_WAH.ogg',
    [CHAR_SOUND_WHOA] = 'Ludwig_CHAR_SOUND_WHOA.ogg',
    [CHAR_SOUND_YAHOO] = 'Ludwig_CHAR_SOUND_YAHOO.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'Ludwig_CHAR_SOUND_YAHOO.ogg', 'Ludwig_CHAR_SOUND_YAHOO_WAHA_YIPPEE.ogg', 'Ludwig_CHAR_SOUND_YAHOO_WAHA_YIPPEE2.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = { 'Ludwig_CHAR_SOUND_YAH_WAH_HOO.ogg', 'Ludwig_CHAR_SOUND_YAH_WAH_HOO2.ogg', 'Ludwig_CHAR_SOUND_YAH_WAH_HOO3.ogg'},
}

local VOICETABLE_ROY = {
    [CHAR_SOUND_ATTACKED] = 'ROY_CHAR_SOUND_ATTACKED.ogg',
    [CHAR_SOUND_COUGHING1] = 'ROY_CHAR_SOUND_COUGHING1.ogg',
    [CHAR_SOUND_COUGHING2] = 'ROY_CHAR_SOUND_COUGHING1.ogg',
    [CHAR_SOUND_DOH] = 'ROY_CHAR_SOUND_DOH.ogg',
    [CHAR_SOUND_DROWNING] = 'ROY_CHAR_SOUND_DROWNING.ogg',
    [CHAR_SOUND_DYING] = 'ROY_CHAR_SOUND_DYING.ogg',
    [CHAR_SOUND_EEUH] = 'ROY_CHAR_SOUND_EEUH.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'ROY_CHAR_SOUND_GROUND_POUND_WAH.ogg',
    [CHAR_SOUND_HAHA] = 'ROY_CHAR_SOUND_HAHA.ogg',
    [CHAR_SOUND_HAHA_2] = 'ROY_CHAR_SOUND_HAHA.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'ROY_CHAR_SOUND_HERE_WE_GO.ogg',
    [CHAR_SOUND_HOOHOO] = 'ROY_CHAR_SOUND_HOOHOO.ogg',
    [CHAR_SOUND_HRMM] = 'ROY_CHAR_SOUND_HRMM.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'ROY_CHAR_SOUND_MAMA_MIA.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'ROY_CHAR_SOUND_LETS_A_GO.ogg',
    [CHAR_SOUND_ON_FIRE] = 'ROY_CHAR_SOUND_ON_FIRE.ogg',
    [CHAR_SOUND_OOOF] = 'ROY_CHAR_SOUND_OOOF.ogg',
    [CHAR_SOUND_OOOF2] = 'ROY_CHAR_SOUND_OOOF2.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'ROY_CHAR_SOUND_PUNCH_HOO.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'ROY_CHAR_SOUND_PUNCH_WAH.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'ROY_CHAR_SOUND_PUNCH_YAH.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'ROY_CHAR_SOUND_SO_LONGA_BOWSER.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'ROY_CHAR_SOUND_TWIRL_BOUNCE.ogg',
    [CHAR_SOUND_UH] = 'ROY_CHAR_SOUND_UH.ogg',
    [CHAR_SOUND_UH2] = 'ROY_CHAR_SOUND_UH2.ogg',
    [CHAR_SOUND_UH2_2] = 'ROY_CHAR_SOUND_UH2.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'ROY_CHAR_SOUND_WAAAOOOW.ogg',
    [CHAR_SOUND_WAH2] = 'ROY_CHAR_SOUND_WAH2.ogg',
    [CHAR_SOUND_WHOA] = 'ROY_CHAR_SOUND_WHOA.ogg',
    [CHAR_SOUND_YAHOO] = 'ROY_CHAR_SOUND_YAHOO.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'ROY_CHAR_SOUND_YAHOO.ogg', 'ROY_CHAR_SOUND_YAHOO_WAHA_YIPPEE.ogg', 'ROY_CHAR_SOUND_YAHOO_WAHA_YIPPEE2.ogg', 'ROY_CHAR_SOUND_YAHOO_WAHA_YIPPEE3.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = { 'ROY_CHAR_SOUND_YAH_WAH_HOO.ogg', 'ROY_CHAR_SOUND_YAH_WAH_HOO2.ogg', 'ROY_CHAR_SOUND_YAH_WAH_HOO3.ogg'},
}

local VOICETABLE_MORTON = {
    [CHAR_SOUND_ATTACKED] = 'MORTON_CHAR_SOUND_ATTACKED.ogg',
    [CHAR_SOUND_COUGHING1] = 'MORTON_CHAR_SOUND_COUGHING1.ogg',
    [CHAR_SOUND_COUGHING2] = 'MORTON_CHAR_SOUND_COUGHING2.ogg',
    [CHAR_SOUND_DOH] = 'MORTON_CHAR_SOUND_DOH.ogg',
    [CHAR_SOUND_DROWNING] = 'MORTON_CHAR_SOUND_DROWNING.ogg',
    [CHAR_SOUND_DYING] = 'MORTON_CHAR_SOUND_DYING.ogg',
    [CHAR_SOUND_EEUH] = 'MORTON_CHAR_SOUND_EEUH.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'MORTON_CHAR_SOUND_GROUND_POUND_WAH.ogg',
    [CHAR_SOUND_HAHA] = 'MORTON_CHAR_SOUND_HAHA.ogg',
    [CHAR_SOUND_HAHA_2] = 'MORTON_CHAR_SOUND_HAHA.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'MORTON_CHAR_SOUND_HERE_WE_GO.ogg',
    [CHAR_SOUND_HOOHOO] = 'MORTON_CHAR_SOUND_HOOHOO.ogg',
    [CHAR_SOUND_HRMM] = 'MORTON_CHAR_SOUND_HRMM.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'MORTON_CHAR_SOUND_MAMA_MIA.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'MORTON_CHAR_SOUND_LETS_A_GO.ogg',
    [CHAR_SOUND_ON_FIRE] = 'MORTON_CHAR_SOUND_ON_FIRE.ogg',
    [CHAR_SOUND_OOOF] = 'MORTON_CHAR_SOUND_OOOF.ogg',
    [CHAR_SOUND_OOOF2] = 'MORTON_CHAR_SOUND_OOOF2.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'MORTON_CHAR_SOUND_PUNCH_HOO.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'MORTON_CHAR_SOUND_PUNCH_WAH.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'MORTON_CHAR_SOUND_PUNCH_YAH.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'MORTON_CHAR_SOUND_SO_LONGA_BOWSER.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'MORTON_CHAR_SOUND_TWIRL_BOUNCE.ogg',
    [CHAR_SOUND_UH] = 'MORTON_CHAR_SOUND_UH2.ogg',
    [CHAR_SOUND_UH2] = 'MORTON_CHAR_SOUND_UH2.ogg',
    [CHAR_SOUND_UH2_2] = 'MORTON_CHAR_SOUND_UH2_2.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'MORTON_CHAR_SOUND_WAAAOOOW.ogg',
    [CHAR_SOUND_WAH2] = 'MORTON_CHAR_SOUND_GROUND_POUND_WAH.ogg',
    [CHAR_SOUND_WHOA] = 'MORTON_CHAR_SOUND_WHOA.ogg',
    [CHAR_SOUND_YAHOO] = 'MORTON_CHAR_SOUND_YAHOO.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'MORTON_CHAR_SOUND_YAHOO.ogg', 'MORTON_CHAR_SOUND_YAHOO_WAHA_YIPPEE.ogg', 'MORTON_CHAR_SOUND_YAHOO_WAHA_YIPPEE2.ogg', 'MORTON_CHAR_SOUND_YAHOO_WAHA_YIPPEE3.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = { 'MORTON_CHAR_SOUND_YAH_WAH_HOO.ogg', 'MORTON_CHAR_SOUND_YAH_WAH_HOO2.ogg', 'MORTON_CHAR_SOUND_YAH_WAH_HOO3.ogg'},
}

local VOICETABLE_IGGY = {
    [CHAR_SOUND_ATTACKED] = 'IGGY_CHAR_SOUND_ATTACKED.ogg',
    [CHAR_SOUND_COUGHING1] = 'IGGY_CHAR_SOUND_COUGHING1.ogg',
    [CHAR_SOUND_COUGHING2] = 'IGGY_CHAR_SOUND_COUGHING1.ogg',
    [CHAR_SOUND_DOH] = 'IGGY_CHAR_SOUND_DOH.ogg',
    [CHAR_SOUND_DROWNING] = 'IGGY_CHAR_SOUND_DROWNING.ogg',
    [CHAR_SOUND_DYING] = 'IGGY_CHAR_SOUND_DYING.ogg',
    [CHAR_SOUND_EEUH] = 'IGGY_CHAR_SOUND_EEUH.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'IGGY_CHAR_SOUND_GROUND_POUND_WAH.ogg',
    [CHAR_SOUND_HAHA] = 'IGGY_CHAR_SOUND_HAHA.ogg',
    [CHAR_SOUND_HAHA_2] = 'IGGY_CHAR_SOUND_HAHA.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'IGGY_CHAR_SOUND_HERE_WE_GO.ogg',
    [CHAR_SOUND_HOOHOO] = 'IGGY_CHAR_SOUND_HOOHOO.ogg',
    [CHAR_SOUND_HRMM] = 'IGGY_CHAR_SOUND_HRMM.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'IGGY_CHAR_SOUND_MAMA_MIA.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'IGGY_CHAR_SOUND_LETS_A_GO.ogg',
    [CHAR_SOUND_ON_FIRE] = 'IGGY_CHAR_SOUND_ON_FIRE.ogg',
    [CHAR_SOUND_OOOF] = 'IGGY_CHAR_SOUND_OOOF.ogg',
    [CHAR_SOUND_OOOF2] = 'IGGY_CHAR_SOUND_OOOF2.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'IGGY_CHAR_SOUND_PUNCH_HOO.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'IGGY_CHAR_SOUND_PUNCH_WAH.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'IGGY_CHAR_SOUND_PUNCH_YAH.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'IGGY_CHAR_SOUND_SO_LONGA_BOWSER.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'IGGY_CHAR_SOUND_TWIRL_BOUNCE.ogg',
    [CHAR_SOUND_UH] = 'IGGY_CHAR_SOUND_UH.ogg',
    [CHAR_SOUND_UH2] = 'IGGY_CHAR_SOUND_UH2.ogg',
    [CHAR_SOUND_UH2_2] = 'IGGY_CHAR_SOUND_UH2.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'IGGY_CHAR_SOUND_WAAAOOOW.ogg',
    [CHAR_SOUND_WAH2] = 'IGGY_CHAR_SOUND_WAH2.ogg',
    [CHAR_SOUND_WHOA] = 'IGGY_CHAR_SOUND_WHOA.ogg',
    [CHAR_SOUND_YAHOO] = 'IGGY_CHAR_SOUND_YAHOO.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'IGGY_CHAR_SOUND_YAHOO.ogg', 'IGGY_CHAR_SOUND_YAHOO_WAHA_YIPPEE.ogg', 'IGGY_CHAR_SOUND_YAHOO_WAHA_YIPPEE1.ogg', 'IGGY_CHAR_SOUND_YAHOO_WAHA_YIPPEE2.ogg', 'IGGY_CHAR_SOUND_YAHOO_WAHA_YIPPEE3.ogg', 'IGGY_CHAR_SOUND_YAHOO_WAHA_YIPPEE4.ogg', 'IGGY_CHAR_SOUND_YAHOO_WAHA_YIPPEE5.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = { 'IGGY_CHAR_SOUND_YAH_WAH_HOO.ogg', 'IGGY_CHAR_SOUND_YAH_WAH_HOO2.ogg', 'IGGY_CHAR_SOUND_YAH_WAH_HOO3.ogg'},
}


local capKoop = {
    normal = smlua_model_util_get_id("koop_cap_geo"),
    wing = smlua_model_util_get_id("koop_wing_cap_geo"),
    metal = smlua_model_util_get_id("koop_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("koop_metal_wing_cap_geo")
}

--Palettes
local PALETTE_LARRY = {
    [SHIRT] = "FFB12C",
    [SHOES] = "ffffff",
    [HAIR] = "4FA3FF",
    [CAP] = "4FA3FF",
    [PANTS] = "428119",
    [GLOVES] = "ffffff",
    [SKIN] = "F5C773",
}

local PALETTE_LEMMY = {
    [SHIRT] = "FFB12C",
    [SHOES] = "ffffff",
    [HAIR] = "ffffff",
    [CAP] = "FFB12C",
    [PANTS] = "428119",
    [GLOVES] = "ffffff",
    [SKIN] = "F5C773",
}

local PALETTE_WENDY = {
    [SHIRT] = "FFB12C",
    [SHOES] = "ffffff",
    [HAIR] = "ffffff",
    [CAP] = "FF75AB",
    [PANTS] = "FF75AB",
    [GLOVES] = "ffffff",
    [SKIN] = "F5C773",
}

local PALETTE_LUDWIG = {
    [SHIRT] = "FFB12C",
    [SHOES] = "ffffff",
    [HAIR] = "2927BE",
    [CAP] = "2927BE",
    [PANTS] = "428119",
    [GLOVES] = "ffffff",
    [SKIN] = "F5C773",
}

local PALETTE_MORTON = {
    [SHIRT] = "76625C",
    [SHOES] = "ffffff",
    [HAIR] = "2A2523",
    [CAP] = "524E42",
    [PANTS] = "FFFFFF",
    [GLOVES] = "ffffff",
    [SKIN] = "F5C773",
}

local PALETTE_ROY = {
    [SHIRT] = "FFB12C",
    [SHOES] = "ffffff",
    [CAP] = "7D56AB",
    [PANTS] = "EB89B6",
    [GLOVES] = "ffffff",
    [SKIN] = "F5C773",
}

local PALETTE_IGGY = {
    [SHIRT] = "FFB12C",
    [SHOES] = "ffffff",
    [CAP] = "8DC52A",
    [PANTS] = "428119",
    [GLOVES] = "ffffff",
    [SKIN] = "F5C773",
    [HAIR] = "A4D735",
}

if _G.charSelectExists then
    CT_LARRY = _G.charSelect.character_add("Larry Koopa", "Bowser's number one Koopaling! That Hairdo is irreristible",
        "Melzinoff & wibblus", { r = 34, g = 208, b = 221 }, E_MODEL_LARRY, CT_MARIO, TEX_LARRY)

    CT_LEMMY = _G.charSelect.character_add("Lemmy Koopa",
        "Also known as the Clown Prince of Koopas, Lemmy would rather join the circus.", "Melzinoff & wibblus",
        { r = 227, g = 95, b = 0 }, E_MODEL_LEMMY, CT_MARIO, TEX_LEMMY)

    CT_WENDY = _G.charSelect.character_add("Wendy O' Koopa",
        "She's bold, bossy, and big headed, despite her tomboyish nature, she's not afraid to show off her feminine side with a pink bow and heels.",
        "Melzinoff & wibblus", { r = 255, g = 111, b = 149 }, E_MODEL_WENDY, CT_MARIO, TEX_WENDY)

    CT_LUDWIG = _G.charSelect.character_add("Ludwig von Koopa",
        "The eldest to the Koopalings, and self proclaimed leader, he's smart but a show off as well. He loves to pose to show his intelligence.",
        "Melzinoff & wibblus", { r = 24, g = 74, b = 209 }, E_MODEL_LUDWIG, CT_MARIO, TEX_LUDWIG)

    CT_MORTON = _G.charSelect.character_add("Morton Koopa Jr",
        "He's a bit slow but he's the strongest Koopaling, some say Morton can stand up to Bowser's strength! He's too loyal to hurt his king though.",
        "Melzinoff & wibblus", { r = 82, g = 78, b = 66 }, E_MODEL_MORTON, CT_MARIO, TEX_MORTON)

    CT_ROY = _G.charSelect.character_add("Roy Koopa",
        "This heavy guy is one of the Koopalings and likes throwing his weight around. His pink sunglasses might not make him seem evil, but the speed he can go from slacker to soldier certainly does.",
        "Melzinoff & wibblus", { r = 255, g = 111, b = 179 }, E_MODEL_ROY, CT_MARIO, TEX_ROY)

    CT_IGGY = _G.charSelect.character_add("Iggy Koopa",
        "Crazed, mechanical genius and childish in personality, despite this demeanor that makes him quite incomprehensible, he is loyal to the koopa family.",
        "Melzinoff & wibblus", { r = 141, g = 197, b = 42 }, E_MODEL_IGGY, CT_MARIO, TEX_IGGY)


    ---- BOWSER MOVESET:
    if _G.bowsMoveset ~= nil then
        -- Retrieves the custom shell model for this character. Check template_shell.blend for how to set up a shell model properly.
        local E_MODEL_M_SHELL = smlua_model_util_get_id("koopaling_medium_shell_geo")
        local E_MODEL_S_SHELL = smlua_model_util_get_id("koopaling_small_shell_geo")
        local E_MODEL_L_SHELL = smlua_model_util_get_id("koopaling_large_shell_geo")
        local E_MODEL_XL_SHELL = smlua_model_util_get_id("koopaling_extralarge_shell_geo")

        -- This is a bitfield of flags that decide which parts of the Bowser Moveset this character will have.
        -- Insert each flag you want to be set, separated by '|' symbols.
        local BOWS_FLAGS_KOOP =
            _G.bowsMoveset.FLAG_CAN_USE_FIREBALL | _G.bowsMoveset.FLAG_CAN_USE_SHELL | _G.bowsMoveset.FLAG_NO_CAPLESS

        -- Flag Options: (sorry the ids are so long pshgkjdf)

        -- _G.bowsMoveset.FLAG_CAN_USE_SHELL
        --- Allows the character to use the shell slide ability.

        -- _G.bowsMoveset.FLAG_CAN_USE_FIREBALL
        --- Allows the character to use the fire breath ability.

        -- _G.bowsMoveset.FLAG_STYLE_ANIMS
        --- Enables Bowser-unique animations for the character.

        -- _G.bowsMoveset.FLAG_SIZE_ANIMS
        --- Adjusts the character's pose in certain animations to suit bowser's large size. (i.e. ledge grab)

        -- _G.bowsMoveset.FLAG_LARGE_HITBOX
        --- Gives the character a larger hitbox size. (37 -> 85 units radius)
        --- This does not affect the hitbox size for level collision, only collisions with objects.

        -- _G.bowsMoveset.FLAG_NO_CAPLESS
        --- The character does not visually lose their 'cap'. Will also use their 'capless' head state in some animations.
        --- Used by Bowser to allow his jaw to open when breathing fire, etc.

        -- _G.bowsMoveset.FLAG_HEAVY_STEPS
        --- Enables heavier landing sound effects for the character.

        -- _G.bowsMoveset.FLAG_ATTACKS
        --- Enables the alternate sliding punch.

        -- _G.bowsMoveset.FLAG_ALL
        --- Shorthand to set all flags.

        -- This function sets up your custom shell model. Feel free to remove this if you aren't using a shell model.
        -- parameters: [your character model], [your shell model]
        _G.bowsMoveset.character_add_shell_model(E_MODEL_LARRY, E_MODEL_M_SHELL, 'shell_jr.ogg')
        _G.bowsMoveset.character_add_shell_model(E_MODEL_LEMMY, E_MODEL_S_SHELL, 'shell_jr.ogg')
        _G.bowsMoveset.character_add_shell_model(E_MODEL_WENDY, E_MODEL_L_SHELL, 'shell_jr.ogg')
        _G.bowsMoveset.character_add_shell_model(E_MODEL_LUDWIG, E_MODEL_L_SHELL, 'shell_jr.ogg')
        _G.bowsMoveset.character_add_shell_model(E_MODEL_MORTON, E_MODEL_XL_SHELL, 'shell_jr.ogg')
        _G.bowsMoveset.character_add_shell_model(E_MODEL_ROY, E_MODEL_XL_SHELL, 'shell_jr.ogg')
        _G.bowsMoveset.character_add_shell_model(E_MODEL_IGGY, E_MODEL_XL_SHELL, 'shell_jr.ogg')

        -- This function sets up the flags for your character.
        -- parameters: [your character model], [your flag bitfield]
        _G.bowsMoveset.character_set_bows_flags(E_MODEL_LARRY, BOWS_FLAGS_KOOP)
        _G.bowsMoveset.character_set_bows_flags(E_MODEL_LEMMY, BOWS_FLAGS_KOOP)
        _G.bowsMoveset.character_set_bows_flags(E_MODEL_WENDY, BOWS_FLAGS_KOOP)
        _G.bowsMoveset.character_set_bows_flags(E_MODEL_LUDWIG, BOWS_FLAGS_KOOP)
        _G.bowsMoveset.character_set_bows_flags(E_MODEL_MORTON, BOWS_FLAGS_KOOP)
        _G.bowsMoveset.character_set_bows_flags(E_MODEL_ROY, BOWS_FLAGS_KOOP)
        _G.bowsMoveset.character_set_bows_flags(E_MODEL_IGGY, BOWS_FLAGS_KOOP)

    end
    ----

    -- Setting up Cap Models for the characters
    _G.charSelect.character_add_caps(E_MODEL_LARRY, capKoop)
    _G.charSelect.character_add_caps(E_MODEL_LEMMY, capKoop)
    _G.charSelect.character_add_caps(E_MODEL_WENDY, capKoop)
    _G.charSelect.character_add_caps(E_MODEL_LUDWIG, capKoop)
    _G.charSelect.character_add_caps(E_MODEL_MORTON, capKoop)
    _G.charSelect.character_add_caps(E_MODEL_ROY, capKoop)
    _G.charSelect.character_add_caps(E_MODEL_IGGY, capKoop)


    --Setting up Palettes
    _G.charSelect.character_add_palette_preset(E_MODEL_LARRY, PALETTE_LARRY)
    _G.charSelect.character_add_palette_preset(E_MODEL_LEMMY, PALETTE_LEMMY)
    _G.charSelect.character_add_palette_preset(E_MODEL_WENDY, PALETTE_WENDY)
    _G.charSelect.character_add_palette_preset(E_MODEL_LUDWIG, PALETTE_LUDWIG)
    _G.charSelect.character_add_palette_preset(E_MODEL_MORTON, PALETTE_MORTON)
    _G.charSelect.character_add_palette_preset(E_MODEL_ROY, PALETTE_ROY)
    _G.charSelect.character_add_palette_preset(E_MODEL_IGGY, PALETTE_IGGY)

    -- the following must be hooked for each character added
    _G.charSelect.character_add_voice(E_MODEL_LARRY, VOICETABLE_LARRY)
    _G.charSelect.character_add_voice(E_MODEL_LEMMY, VOICETABLE_LEMMY)
    _G.charSelect.character_add_voice(E_MODEL_WENDY, VOICETABLE_WENDY)
    _G.charSelect.character_add_voice(E_MODEL_LUDWIG, VOICETABLE_LUDWIG)
    _G.charSelect.character_add_voice(E_MODEL_MORTON, VOICETABLE_MORTON)
    _G.charSelect.character_add_voice(E_MODEL_ROY, VOICETABLE_ROY)
    _G.charSelect.character_add_voice(E_MODEL_IGGY, VOICETABLE_IGGY)


    hook_event(HOOK_CHARACTER_SOUND, function(m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_LARRY then return _G.charSelect.voice.sound(m, sound) end
        if _G.charSelect.character_get_voice(m) == VOICETABLE_LEMMY then return _G.charSelect.voice.sound(m, sound) end
        if _G.charSelect.character_get_voice(m) == VOICETABLE_WENDY then return _G.charSelect.voice.sound(m, sound) end
        if _G.charSelect.character_get_voice(m) == VOICETABLE_LUDWIG then return _G.charSelect.voice.sound(m, sound) end
        if _G.charSelect.character_get_voice(m) == VOICETABLE_MORTON then return _G.charSelect.voice.sound(m, sound) end
        if _G.charSelect.character_get_voice(m) == VOICETABLE_ROY then return _G.charSelect.voice.sound(m, sound) end
        if _G.charSelect.character_get_voice(m) == VOICETABLE_IGGY then return _G.charSelect.voice.sound(m, sound) end

    end)
    hook_event(HOOK_MARIO_UPDATE, function(m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_LARRY then return _G.charSelect.voice.snore(m) end
        if _G.charSelect.character_get_voice(m) == VOICETABLE_LEMMY then return _G.charSelect.voice.snore(m) end
        if _G.charSelect.character_get_voice(m) == VOICETABLE_WENDY then return _G.charSelect.voice.snore(m) end
        if _G.charSelect.character_get_voice(m) == VOICETABLE_LUDWIG then return _G.charSelect.voice.snore(m) end
        if _G.charSelect.character_get_voice(m) == VOICETABLE_MORTON then return _G.charSelect.voice.snore(m) end
        if _G.charSelect.character_get_voice(m) == VOICETABLE_ROY then return _G.charSelect.voice.snore(m) end
        if _G.charSelect.character_get_voice(m) == VOICETABLE_IGGY then return _G.charSelect.voice.snore(m) end
    end)
end
